//////////////////////////////////////////////////////////////////////
// Subroutine SPD_HoldFrame.
//////////////////////////////////////////////////////////////////////
void SPD_HoldFrame(int SPD_HoldFrame__maxFPS) throws NaaLaaEndException {
// Locals.
int SPD_HoldFrame__hold = 0;
int SPD_HoldFrame__t = 0;

		SPD_HoldFrame__hold = 1000/SPD_HoldFrame__maxFPS;
		SPD_HoldFrame__t = naalaa_Time();
		if (Math.abs(SPD_HoldFrame__t - tm_NextFrameTime) > SPD_HoldFrame__hold*10) {
			tm_NextFrameTime = SPD_HoldFrame__t;
		}
		while (naalaa_Time() < tm_NextFrameTime) {
			try {Thread.sleep(1);} catch (InterruptedException e) {}
		}
		tm_NextFrameTime = tm_NextFrameTime + SPD_HoldFrame__hold;
	}

//////////////////////////////////////////////////////////////////////
// Subroutine SPD_HoldFrameDraw.
//////////////////////////////////////////////////////////////////////
int SPD_HoldFrameDraw(int SPD_HoldFrameDraw__fps) throws NaaLaaEndException {
// Locals.
int SPD_HoldFrameDraw__delay = 0;

		SPD_HoldFrameDraw__delay = 1000/SPD_HoldFrameDraw__fps;
		if (naalaa_Time() < spd_LastTime + SPD_HoldFrameDraw__delay) {
			while (naalaa_Time() < spd_LastTime + SPD_HoldFrameDraw__delay) {
				try {Thread.sleep(1);} catch (InterruptedException e) {}
			}
			spd_LastTime = spd_LastTime + SPD_HoldFrameDraw__delay;
			return 1;
		} else {
			if (naalaa_Time() - spd_LastTime > SPD_HoldFrameDraw__delay*10) {
				spd_LastTime = naalaa_Time() + SPD_HoldFrameDraw__delay;
			} else {
				spd_LastTime = spd_LastTime + SPD_HoldFrameDraw__delay;
			}
			return 0;
		}
	}

//////////////////////////////////////////////////////////////////////
// Subroutine SPD_GetSpeedCorrection.
//////////////////////////////////////////////////////////////////////
float SPD_GetSpeedCorrection() throws NaaLaaEndException {
// Locals.
int SPD_GetSpeedCorrection__t = 0;
int SPD_GetSpeedCorrection__dt = 0;
float SPD_GetSpeedCorrection__k = 0.0f;

		SPD_GetSpeedCorrection__t = naalaa_Time();
		SPD_GetSpeedCorrection__dt = Math.min(SPD_GetSpeedCorrection__t - spd_StartTime, spd_FPSLock);
		spd_FPS = 1000/Math.max(SPD_GetSpeedCorrection__dt, 1);
		SPD_GetSpeedCorrection__k = naalaa_ToFloat(SPD_GetSpeedCorrection__dt)*0.001000f;
		spd_StartTime = SPD_GetSpeedCorrection__t;
		return SPD_GetSpeedCorrection__k;
	}

//////////////////////////////////////////////////////////////////////
// Subroutine SPD_SetFPSLock.
//////////////////////////////////////////////////////////////////////
void SPD_SetFPSLock(int SPD_SetFPSLock__minFPS) throws NaaLaaEndException {
		spd_FPSLock = 1000/SPD_SetFPSLock__minFPS;
	}

//////////////////////////////////////////////////////////////////////
// Subroutine SPD_GetFPS.
//////////////////////////////////////////////////////////////////////
int SPD_GetFPS() throws NaaLaaEndException {
		return spd_FPS;
	}

//////////////////////////////////////////////////////////////////////
// Subroutine SP_Init.
//////////////////////////////////////////////////////////////////////
void SP_Init(int SP_Init__maxParticles) throws NaaLaaEndException {
// Locals.
int SP_Init__i = 0;

		prt_ParticleCounter = 0;
		prt_MaxParticles = SP_Init__maxParticles;
		prt_Particles = new Integer[prt_MaxParticles][5];
naalaa_IntArrayInit(prt_Particles);
		prt_ParticlesF = new Float[prt_MaxParticles][10];
naalaa_FloatArrayInit(prt_ParticlesF);
		for (SP_Init__i = 0; SP_Init__i <= prt_MaxParticles - 1; SP_Init__i++) {
			prt_Particles[SP_Init__i][PRT_TYPE] = 0;
		}
	}

//////////////////////////////////////////////////////////////////////
// Subroutine SP_AddParticle.
//////////////////////////////////////////////////////////////////////
void SP_AddParticle(int SP_AddParticle__img, int SP_AddParticle__cel, int SP_AddParticle__addMode, int SP_AddParticle__x, int SP_AddParticle__y, float SP_AddParticle__srcDX, float SP_AddParticle__srcDY, float SP_AddParticle__dstDX, float SP_AddParticle__dstDY, float SP_AddParticle__srcAlpha, float SP_AddParticle__dstAlpha, float SP_AddParticle__speed, int SP_AddParticle__pause) throws NaaLaaEndException {
		prt_Particles[prt_ParticleCounter][PRT_TYPE] = 1;
		prt_Particles[prt_ParticleCounter][PRT_IMAGE] = SP_AddParticle__img;
		if (SP_AddParticle__cel ==  - 2) {
			SP_AddParticle__cel = naalaa_Random.nextInt(naalaa_Cels(SP_AddParticle__img));
		}
		prt_Particles[prt_ParticleCounter][PRT_CEL] = SP_AddParticle__cel;
		prt_Particles[prt_ParticleCounter][PRT_ADDITIVE] = SP_AddParticle__addMode;
		prt_Particles[prt_ParticleCounter][PRT_PAUSE] = SP_AddParticle__pause;
		prt_ParticlesF[prt_ParticleCounter][PRT_X] = naalaa_ToFloat(SP_AddParticle__x) - naalaa_ToFloat(naalaa_Width(SP_AddParticle__img))*0.500000f;
		prt_ParticlesF[prt_ParticleCounter][PRT_Y] = naalaa_ToFloat(SP_AddParticle__y) - naalaa_ToFloat(naalaa_Height(SP_AddParticle__img))*0.500000f;
		prt_ParticlesF[prt_ParticleCounter][PRT_PARAM] = 0.000000f;
		prt_ParticlesF[prt_ParticleCounter][PRT_SPEED] = SP_AddParticle__speed;
		prt_ParticlesF[prt_ParticleCounter][PRT_SRC_DX] = SP_AddParticle__srcDX;
		prt_ParticlesF[prt_ParticleCounter][PRT_SRC_DY] = SP_AddParticle__srcDY;
		prt_ParticlesF[prt_ParticleCounter][PRT_DST_DX] = SP_AddParticle__dstDX;
		prt_ParticlesF[prt_ParticleCounter][PRT_DST_DY] = SP_AddParticle__dstDY;
		prt_ParticlesF[prt_ParticleCounter][PRT_SRC_A] = SP_AddParticle__srcAlpha*255.000000f;
		prt_ParticlesF[prt_ParticleCounter][PRT_DST_A] = SP_AddParticle__dstAlpha*255.000000f;
		prt_ParticleCounter = (prt_ParticleCounter + 1)%prt_MaxParticles;
	}

//////////////////////////////////////////////////////////////////////
// Subroutine SP_AddParticleAt.
//////////////////////////////////////////////////////////////////////
void SP_AddParticleAt(int SP_AddParticleAt__x, int SP_AddParticleAt__y) throws NaaLaaEndException {
		prt_Particles[prt_ParticleCounter][PRT_TYPE] = 1;
		prt_Particles[prt_ParticleCounter][PRT_IMAGE] = prt_Image;
		prt_Particles[prt_ParticleCounter][PRT_CEL] = prt_Cel;
		prt_Particles[prt_ParticleCounter][PRT_ADDITIVE] = prt_Additive;
		prt_Particles[prt_ParticleCounter][PRT_PAUSE] = prt_Pause;
		prt_ParticlesF[prt_ParticleCounter][PRT_X] = naalaa_ToFloat(SP_AddParticleAt__x) - naalaa_ToFloat(naalaa_Width(prt_Image))*0.500000f;
		prt_ParticlesF[prt_ParticleCounter][PRT_Y] = naalaa_ToFloat(SP_AddParticleAt__y) - naalaa_ToFloat(naalaa_Height(prt_Image))*0.500000f;
		prt_ParticlesF[prt_ParticleCounter][PRT_PARAM] = 0.000000f;
		prt_ParticlesF[prt_ParticleCounter][PRT_SPEED] = prt_Speed;
		prt_ParticlesF[prt_ParticleCounter][PRT_SRC_DX] = prt_SrcDX;
		prt_ParticlesF[prt_ParticleCounter][PRT_SRC_DY] = prt_SrcDY;
		prt_ParticlesF[prt_ParticleCounter][PRT_DST_DX] = prt_DstDX;
		prt_ParticlesF[prt_ParticleCounter][PRT_DST_DY] = prt_DstDY;
		prt_ParticlesF[prt_ParticleCounter][PRT_SRC_A] = prt_SrcA*255.000000f;
		prt_ParticlesF[prt_ParticleCounter][PRT_DST_A] = prt_DstA*255.000000f;
		prt_ParticleCounter = (prt_ParticleCounter + 1)%prt_MaxParticles;
	}

//////////////////////////////////////////////////////////////////////
// Subroutine SP_SetPoofEndVector.
//////////////////////////////////////////////////////////////////////
void SP_SetPoofEndVector(float SP_SetPoofEndVector__ex, float SP_SetPoofEndVector__ey) throws NaaLaaEndException {
		prt_PoffEX = SP_SetPoofEndVector__ex;
		prt_PoffEY = SP_SetPoofEndVector__ey;
	}

//////////////////////////////////////////////////////////////////////
// Subroutine SP_AddPoof.
//////////////////////////////////////////////////////////////////////
void SP_AddPoof(int SP_AddPoof__img, int SP_AddPoof__cel, int SP_AddPoof__x, int SP_AddPoof__y, int SP_AddPoof__particleCount, float SP_AddPoof__distance, float SP_AddPoof__force, float SP_AddPoof__speed, int SP_AddPoof__addMode, int SP_AddPoof__fadeOut) throws NaaLaaEndException {
// Locals.
float SP_AddPoof__astep = 0.0f;
float SP_AddPoof__a = 0.0f;
float SP_AddPoof__dstAlpha = 0.0f;
int SP_AddPoof__i = 0;
float SP_AddPoof__c = 0.0f;
float SP_AddPoof__s = 0.0f;

		SP_AddPoof__astep = 360.000000f/naalaa_ToFloat(SP_AddPoof__particleCount);
		SP_AddPoof__a = 0.000000f;
		if (SP_AddPoof__fadeOut != 0 ) {
			SP_AddPoof__dstAlpha = 0.000000f;
		} else {
			SP_AddPoof__dstAlpha = 1.000000f;
		}
		for (SP_AddPoof__i = 1; SP_AddPoof__i <= SP_AddPoof__particleCount; SP_AddPoof__i++) {
			SP_AddPoof__c = (float)Math.cos(naalaa_InAngleMul*(double)(SP_AddPoof__a));
			SP_AddPoof__s = (float)Math.sin(naalaa_InAngleMul*(double)(SP_AddPoof__a));
			SP_AddParticle(SP_AddPoof__img, SP_AddPoof__cel, SP_AddPoof__addMode, SP_AddPoof__x + naalaa_ToInt(SP_AddPoof__c*SP_AddPoof__distance), SP_AddPoof__y + naalaa_ToInt(SP_AddPoof__s*SP_AddPoof__distance), SP_AddPoof__c*SP_AddPoof__force, SP_AddPoof__s*SP_AddPoof__force, prt_PoffEX, prt_PoffEY, 1.000000f, SP_AddPoof__dstAlpha, SP_AddPoof__speed, 0);
			SP_AddPoof__a = SP_AddPoof__a + SP_AddPoof__astep;
		}
	}

//////////////////////////////////////////////////////////////////////
// Subroutine SP_AddRandomPoof.
//////////////////////////////////////////////////////////////////////
void SP_AddRandomPoof(int SP_AddRandomPoof__img, int SP_AddRandomPoof__cel, int SP_AddRandomPoof__x, int SP_AddRandomPoof__y, int SP_AddRandomPoof__particleCount, float SP_AddRandomPoof__maxDistance, float SP_AddRandomPoof__maxForce, float SP_AddRandomPoof__maxSpeed, int SP_AddRandomPoof__addMode, int SP_AddRandomPoof__fadeOut) throws NaaLaaEndException {
// Locals.
float SP_AddRandomPoof__astep = 0.0f;
float SP_AddRandomPoof__hastep = 0.0f;
int SP_AddRandomPoof__iastep = 0;
float SP_AddRandomPoof__a = 0.0f;
int SP_AddRandomPoof__imaxForce = 0;
int SP_AddRandomPoof__imaxDistance = 0;
int SP_AddRandomPoof__imaxSpeed = 0;
float SP_AddRandomPoof__dstAlpha = 0.0f;
int SP_AddRandomPoof__i = 0;
float SP_AddRandomPoof__ua = 0.0f;
float SP_AddRandomPoof__c = 0.0f;
float SP_AddRandomPoof__s = 0.0f;
float SP_AddRandomPoof__f = 0.0f;
float SP_AddRandomPoof__d = 0.0f;
float SP_AddRandomPoof__spd = 0.0f;

		SP_AddRandomPoof__astep = 360.000000f/naalaa_ToFloat(SP_AddRandomPoof__particleCount);
		SP_AddRandomPoof__hastep = SP_AddRandomPoof__astep*0.500000f;
		SP_AddRandomPoof__iastep = 360/SP_AddRandomPoof__particleCount;
		SP_AddRandomPoof__a = 0.000000f;
		SP_AddRandomPoof__maxForce = SP_AddRandomPoof__maxForce*0.500000f;
		SP_AddRandomPoof__imaxForce = naalaa_ToInt(SP_AddRandomPoof__maxForce*1000.000000f);
		SP_AddRandomPoof__maxDistance = SP_AddRandomPoof__maxDistance*0.500000f;
		SP_AddRandomPoof__imaxDistance = naalaa_ToInt(SP_AddRandomPoof__maxDistance*1000.000000f);
		SP_AddRandomPoof__maxSpeed = SP_AddRandomPoof__maxSpeed*0.500000f;
		SP_AddRandomPoof__imaxSpeed = naalaa_ToInt(SP_AddRandomPoof__maxSpeed*1000.000000f);
		if (SP_AddRandomPoof__fadeOut != 0 ) {
			SP_AddRandomPoof__dstAlpha = 0.000000f;
		} else {
			SP_AddRandomPoof__dstAlpha = 1.000000f;
		}
		for (SP_AddRandomPoof__i = 1; SP_AddRandomPoof__i <= SP_AddRandomPoof__particleCount; SP_AddRandomPoof__i++) {
						SP_AddRandomPoof__ua = SP_AddRandomPoof__a + naalaa_ToFloat(naalaa_Random.nextInt(SP_AddRandomPoof__iastep)) - SP_AddRandomPoof__hastep;
			SP_AddRandomPoof__c = (float)Math.cos(naalaa_InAngleMul*(double)(SP_AddRandomPoof__ua));
			SP_AddRandomPoof__s = (float)Math.sin(naalaa_InAngleMul*(double)(SP_AddRandomPoof__ua));
						SP_AddRandomPoof__f = (SP_AddRandomPoof__maxForce + naalaa_ToFloat(naalaa_Random.nextInt(SP_AddRandomPoof__imaxForce))*0.001000f);
						SP_AddRandomPoof__d = (SP_AddRandomPoof__maxDistance + naalaa_ToFloat(naalaa_Random.nextInt(SP_AddRandomPoof__imaxDistance))*0.001000f);
						SP_AddRandomPoof__spd = (SP_AddRandomPoof__maxSpeed + naalaa_ToFloat(naalaa_Random.nextInt(SP_AddRandomPoof__imaxSpeed))*0.001000f);
			SP_AddParticle(SP_AddRandomPoof__img, SP_AddRandomPoof__cel, SP_AddRandomPoof__addMode, SP_AddRandomPoof__x + naalaa_ToInt(SP_AddRandomPoof__c*SP_AddRandomPoof__d), SP_AddRandomPoof__y + naalaa_ToInt(SP_AddRandomPoof__s*SP_AddRandomPoof__d), SP_AddRandomPoof__c*SP_AddRandomPoof__f, SP_AddRandomPoof__s*SP_AddRandomPoof__f, prt_PoffEX, prt_PoffEY, 1.000000f, SP_AddRandomPoof__dstAlpha, SP_AddRandomPoof__spd, 0);
			SP_AddRandomPoof__a = SP_AddRandomPoof__a + SP_AddRandomPoof__astep;
		}
	}

//////////////////////////////////////////////////////////////////////
// Subroutine SP_SetImage.
//////////////////////////////////////////////////////////////////////
void SP_SetImage(int SP_SetImage__img, int SP_SetImage__cel, int SP_SetImage__addMode) throws NaaLaaEndException {
		prt_Image = SP_SetImage__img;
		if (SP_SetImage__cel ==  - 2) {
			SP_SetImage__cel = naalaa_Random.nextInt(naalaa_Cels(SP_SetImage__img));
		}
		prt_Cel = SP_SetImage__cel;
		prt_Additive = SP_SetImage__addMode;
	}

//////////////////////////////////////////////////////////////////////
// Subroutine SP_SetDirection.
//////////////////////////////////////////////////////////////////////
void SP_SetDirection(float SP_SetDirection__srcDX, float SP_SetDirection__srcDY, float SP_SetDirection__dstDX, float SP_SetDirection__dstDY) throws NaaLaaEndException {
		prt_SrcDX = SP_SetDirection__srcDX;
		prt_SrcDY = SP_SetDirection__srcDY;
		prt_DstDX = SP_SetDirection__dstDX;
		prt_DstDY = SP_SetDirection__dstDY;
	}

//////////////////////////////////////////////////////////////////////
// Subroutine SP_SetAlpha.
//////////////////////////////////////////////////////////////////////
void SP_SetAlpha(float SP_SetAlpha__srcAlpha, float SP_SetAlpha__dstAlpha) throws NaaLaaEndException {
		prt_SrcA = SP_SetAlpha__srcAlpha;
		prt_DstA = SP_SetAlpha__dstAlpha;
	}

//////////////////////////////////////////////////////////////////////
// Subroutine SP_SetSpeed.
//////////////////////////////////////////////////////////////////////
void SP_SetSpeed(float SP_SetSpeed__speed) throws NaaLaaEndException {
		prt_Speed = SP_SetSpeed__speed;
	}

//////////////////////////////////////////////////////////////////////
// Subroutine SP_SetPause.
//////////////////////////////////////////////////////////////////////
void SP_SetPause(int SP_SetPause__pause) throws NaaLaaEndException {
		prt_Pause = SP_SetPause__pause;
	}

//////////////////////////////////////////////////////////////////////
// Subroutine SP_UpdateParticles.
//////////////////////////////////////////////////////////////////////
void SP_UpdateParticles() throws NaaLaaEndException {
// Locals.
int SP_UpdateParticles__i = 0;
float SP_UpdateParticles__prm = 0.0f;
float SP_UpdateParticles__dx = 0.0f;
float SP_UpdateParticles__dy = 0.0f;

		for (SP_UpdateParticles__i = 0; SP_UpdateParticles__i <= prt_MaxParticles - 1; SP_UpdateParticles__i++) {
			if (prt_Particles[SP_UpdateParticles__i][PRT_TYPE] > 0) {
				prt_Particles[SP_UpdateParticles__i][PRT_PAUSE] = prt_Particles[SP_UpdateParticles__i][PRT_PAUSE] - 1;
				if (prt_Particles[SP_UpdateParticles__i][PRT_PAUSE] <= 0) {
					SP_UpdateParticles__prm = prt_ParticlesF[SP_UpdateParticles__i][PRT_PARAM];
					SP_UpdateParticles__prm = SP_UpdateParticles__prm + prt_ParticlesF[SP_UpdateParticles__i][PRT_SPEED];
					if (SP_UpdateParticles__prm > 1.000000f) {
						prt_Particles[SP_UpdateParticles__i][PRT_TYPE] = 0;
					} else {
						prt_ParticlesF[SP_UpdateParticles__i][PRT_PARAM] = SP_UpdateParticles__prm;
						SP_UpdateParticles__dx = (1.000000f - SP_UpdateParticles__prm)*prt_ParticlesF[SP_UpdateParticles__i][PRT_SRC_DX] + SP_UpdateParticles__prm*prt_ParticlesF[SP_UpdateParticles__i][PRT_DST_DX];
						SP_UpdateParticles__dy = (1.000000f - SP_UpdateParticles__prm)*prt_ParticlesF[SP_UpdateParticles__i][PRT_SRC_DY] + SP_UpdateParticles__prm*prt_ParticlesF[SP_UpdateParticles__i][PRT_DST_DY];
						prt_ParticlesF[SP_UpdateParticles__i][PRT_X] = prt_ParticlesF[SP_UpdateParticles__i][PRT_X] + SP_UpdateParticles__dx;
						prt_ParticlesF[SP_UpdateParticles__i][PRT_Y] = prt_ParticlesF[SP_UpdateParticles__i][PRT_Y] + SP_UpdateParticles__dy;
					}
				}
			}
		}
	}

//////////////////////////////////////////////////////////////////////
// Subroutine SP_DrawParticles.
//////////////////////////////////////////////////////////////////////
void SP_DrawParticles() throws NaaLaaEndException {
// Locals.
int SP_DrawParticles__i = 0;
float SP_DrawParticles__prm = 0.0f;
int SP_DrawParticles__cel = 0;

		for (SP_DrawParticles__i = 0; SP_DrawParticles__i <= prt_MaxParticles - 1; SP_DrawParticles__i++) {
			if (prt_Particles[SP_DrawParticles__i][PRT_TYPE] > 0) {
				// prt_Particles[SP_DrawParticles__i][PRT_ADDITIVE]
				SP_DrawParticles__prm = prt_ParticlesF[SP_DrawParticles__i][PRT_PARAM];
				setColor(255, 255, 255, naalaa_ToInt((1.000000f - SP_DrawParticles__prm)*prt_ParticlesF[SP_DrawParticles__i][PRT_SRC_A] + SP_DrawParticles__prm*prt_ParticlesF[SP_DrawParticles__i][PRT_DST_A]));
				if (prt_Particles[SP_DrawParticles__i][PRT_CEL] ==  - 1) {
					SP_DrawParticles__cel = naalaa_ToInt(SP_DrawParticles__prm*naalaa_ToFloat(naalaa_Cels(prt_Particles[SP_DrawParticles__i][PRT_IMAGE])));
					naalaa_DrawImage(prt_Particles[SP_DrawParticles__i][PRT_IMAGE], naalaa_ToInt(prt_ParticlesF[SP_DrawParticles__i][PRT_X]), naalaa_ToInt(prt_ParticlesF[SP_DrawParticles__i][PRT_Y]), SP_DrawParticles__cel);
				} else {
					naalaa_DrawImage(prt_Particles[SP_DrawParticles__i][PRT_IMAGE], naalaa_ToInt(prt_ParticlesF[SP_DrawParticles__i][PRT_X]), naalaa_ToInt(prt_ParticlesF[SP_DrawParticles__i][PRT_Y]), prt_Particles[SP_DrawParticles__i][PRT_CEL]);
				}
			}
		}
		// 0
		setColor(255, 255, 255, 255);
	}

//////////////////////////////////////////////////////////////////////
// Subroutine SP_DrawParticlesAt.
//////////////////////////////////////////////////////////////////////
void SP_DrawParticlesAt(int SP_DrawParticlesAt__x, int SP_DrawParticlesAt__y) throws NaaLaaEndException {
// Locals.
int SP_DrawParticlesAt__i = 0;
float SP_DrawParticlesAt__prm = 0.0f;
int SP_DrawParticlesAt__cel = 0;

		for (SP_DrawParticlesAt__i = 0; SP_DrawParticlesAt__i <= prt_MaxParticles - 1; SP_DrawParticlesAt__i++) {
			if (prt_Particles[SP_DrawParticlesAt__i][PRT_TYPE] > 0) {
				// prt_Particles[SP_DrawParticlesAt__i][PRT_ADDITIVE]
				SP_DrawParticlesAt__prm = prt_ParticlesF[SP_DrawParticlesAt__i][PRT_PARAM];
				setColor(255, 255, 255, naalaa_ToInt((1.000000f - SP_DrawParticlesAt__prm)*prt_ParticlesF[SP_DrawParticlesAt__i][PRT_SRC_A] + SP_DrawParticlesAt__prm*prt_ParticlesF[SP_DrawParticlesAt__i][PRT_DST_A]));
				if (prt_Particles[SP_DrawParticlesAt__i][PRT_CEL] ==  - 1) {
					SP_DrawParticlesAt__cel = naalaa_ToInt(SP_DrawParticlesAt__prm*naalaa_ToFloat(naalaa_Cels(prt_Particles[SP_DrawParticlesAt__i][PRT_IMAGE])));
					naalaa_DrawImage(prt_Particles[SP_DrawParticlesAt__i][PRT_IMAGE], SP_DrawParticlesAt__x + naalaa_ToInt(prt_ParticlesF[SP_DrawParticlesAt__i][PRT_X]), SP_DrawParticlesAt__y + naalaa_ToInt(prt_ParticlesF[SP_DrawParticlesAt__i][PRT_Y]), SP_DrawParticlesAt__cel);
				} else {
					naalaa_DrawImage(prt_Particles[SP_DrawParticlesAt__i][PRT_IMAGE], SP_DrawParticlesAt__x + naalaa_ToInt(prt_ParticlesF[SP_DrawParticlesAt__i][PRT_X]), SP_DrawParticlesAt__y + naalaa_ToInt(prt_ParticlesF[SP_DrawParticlesAt__i][PRT_Y]), prt_Particles[SP_DrawParticlesAt__i][PRT_CEL]);
				}
			}
		}
		// 0
		setColor(255, 255, 255, 255);
	}

//////////////////////////////////////////////////////////////////////
// Subroutine SP_DoParticles.
//////////////////////////////////////////////////////////////////////
void SP_DoParticles() throws NaaLaaEndException {
// Locals.
int SP_DoParticles__i = 0;
float SP_DoParticles__prm = 0.0f;
float SP_DoParticles__dx = 0.0f;
float SP_DoParticles__dy = 0.0f;
int SP_DoParticles__cel = 0;

		for (SP_DoParticles__i = 0; SP_DoParticles__i <= prt_MaxParticles - 1; SP_DoParticles__i++) {
			if (prt_Particles[SP_DoParticles__i][PRT_TYPE] > 0) {
				prt_Particles[SP_DoParticles__i][PRT_PAUSE] = prt_Particles[SP_DoParticles__i][PRT_PAUSE] - 1;
				if (prt_Particles[SP_DoParticles__i][PRT_PAUSE] <= 0) {
					SP_DoParticles__prm = prt_ParticlesF[SP_DoParticles__i][PRT_PARAM];
					SP_DoParticles__prm = SP_DoParticles__prm + prt_ParticlesF[SP_DoParticles__i][PRT_SPEED];
					if (SP_DoParticles__prm > 1.000000f) {
						prt_Particles[SP_DoParticles__i][PRT_TYPE] = 0;
					} else {
						prt_ParticlesF[SP_DoParticles__i][PRT_PARAM] = SP_DoParticles__prm;
						SP_DoParticles__dx = (1.000000f - SP_DoParticles__prm)*prt_ParticlesF[SP_DoParticles__i][PRT_SRC_DX] + SP_DoParticles__prm*prt_ParticlesF[SP_DoParticles__i][PRT_DST_DX];
						SP_DoParticles__dy = (1.000000f - SP_DoParticles__prm)*prt_ParticlesF[SP_DoParticles__i][PRT_SRC_DY] + SP_DoParticles__prm*prt_ParticlesF[SP_DoParticles__i][PRT_DST_DY];
						prt_ParticlesF[SP_DoParticles__i][PRT_X] = prt_ParticlesF[SP_DoParticles__i][PRT_X] + SP_DoParticles__dx;
						prt_ParticlesF[SP_DoParticles__i][PRT_Y] = prt_ParticlesF[SP_DoParticles__i][PRT_Y] + SP_DoParticles__dy;
						// prt_Particles[SP_DoParticles__i][PRT_ADDITIVE]
						SP_DoParticles__prm = prt_ParticlesF[SP_DoParticles__i][PRT_PARAM];
						setColor(255, 255, 255, naalaa_ToInt((1.000000f - SP_DoParticles__prm)*prt_ParticlesF[SP_DoParticles__i][PRT_SRC_A] + SP_DoParticles__prm*prt_ParticlesF[SP_DoParticles__i][PRT_DST_A]));
						if (prt_Particles[SP_DoParticles__i][PRT_CEL] ==  - 1) {
							SP_DoParticles__cel = naalaa_ToInt(SP_DoParticles__prm*naalaa_ToFloat(naalaa_Cels(prt_Particles[SP_DoParticles__i][PRT_IMAGE])));
							naalaa_DrawImage(prt_Particles[SP_DoParticles__i][PRT_IMAGE], naalaa_ToInt(prt_ParticlesF[SP_DoParticles__i][PRT_X]), naalaa_ToInt(prt_ParticlesF[SP_DoParticles__i][PRT_Y]), SP_DoParticles__cel);
						} else {
							naalaa_DrawImage(prt_Particles[SP_DoParticles__i][PRT_IMAGE], naalaa_ToInt(prt_ParticlesF[SP_DoParticles__i][PRT_X]), naalaa_ToInt(prt_ParticlesF[SP_DoParticles__i][PRT_Y]), prt_Particles[SP_DoParticles__i][PRT_CEL]);
						}
					}
				}
			}
		}
		// 0
		setColor(255, 255, 255, 255);
	}

//////////////////////////////////////////////////////////////////////
// Subroutine SP_DoParticlesAt.
//////////////////////////////////////////////////////////////////////
void SP_DoParticlesAt(int SP_DoParticlesAt__x, int SP_DoParticlesAt__y) throws NaaLaaEndException {
// Locals.
int SP_DoParticlesAt__i = 0;
float SP_DoParticlesAt__prm = 0.0f;
float SP_DoParticlesAt__dx = 0.0f;
float SP_DoParticlesAt__dy = 0.0f;
int SP_DoParticlesAt__cel = 0;

		for (SP_DoParticlesAt__i = 0; SP_DoParticlesAt__i <= prt_MaxParticles - 1; SP_DoParticlesAt__i++) {
			if (prt_Particles[SP_DoParticlesAt__i][PRT_TYPE] > 0) {
				prt_Particles[SP_DoParticlesAt__i][PRT_PAUSE] = prt_Particles[SP_DoParticlesAt__i][PRT_PAUSE] - 1;
				if (prt_Particles[SP_DoParticlesAt__i][PRT_PAUSE] <= 0) {
					SP_DoParticlesAt__prm = prt_ParticlesF[SP_DoParticlesAt__i][PRT_PARAM];
					SP_DoParticlesAt__prm = SP_DoParticlesAt__prm + prt_ParticlesF[SP_DoParticlesAt__i][PRT_SPEED];
					if (SP_DoParticlesAt__prm > 1.000000f) {
						prt_Particles[SP_DoParticlesAt__i][PRT_TYPE] = 0;
					} else {
						prt_ParticlesF[SP_DoParticlesAt__i][PRT_PARAM] = SP_DoParticlesAt__prm;
						SP_DoParticlesAt__dx = (1.000000f - SP_DoParticlesAt__prm)*prt_ParticlesF[SP_DoParticlesAt__i][PRT_SRC_DX] + SP_DoParticlesAt__prm*prt_ParticlesF[SP_DoParticlesAt__i][PRT_DST_DX];
						SP_DoParticlesAt__dy = (1.000000f - SP_DoParticlesAt__prm)*prt_ParticlesF[SP_DoParticlesAt__i][PRT_SRC_DY] + SP_DoParticlesAt__prm*prt_ParticlesF[SP_DoParticlesAt__i][PRT_DST_DY];
						prt_ParticlesF[SP_DoParticlesAt__i][PRT_X] = prt_ParticlesF[SP_DoParticlesAt__i][PRT_X] + SP_DoParticlesAt__dx;
						prt_ParticlesF[SP_DoParticlesAt__i][PRT_Y] = prt_ParticlesF[SP_DoParticlesAt__i][PRT_Y] + SP_DoParticlesAt__dy;
						// prt_Particles[SP_DoParticlesAt__i][PRT_ADDITIVE]
						SP_DoParticlesAt__prm = prt_ParticlesF[SP_DoParticlesAt__i][PRT_PARAM];
						setColor(255, 255, 255, naalaa_ToInt((1.000000f - SP_DoParticlesAt__prm)*prt_ParticlesF[SP_DoParticlesAt__i][PRT_SRC_A] + SP_DoParticlesAt__prm*prt_ParticlesF[SP_DoParticlesAt__i][PRT_DST_A]));
						if (prt_Particles[SP_DoParticlesAt__i][PRT_CEL] ==  - 1) {
							SP_DoParticlesAt__cel = naalaa_ToInt(SP_DoParticlesAt__prm*naalaa_ToFloat(naalaa_Cels(prt_Particles[SP_DoParticlesAt__i][PRT_IMAGE])));
							naalaa_DrawImage(prt_Particles[SP_DoParticlesAt__i][PRT_IMAGE], SP_DoParticlesAt__x + naalaa_ToInt(prt_ParticlesF[SP_DoParticlesAt__i][PRT_X]), SP_DoParticlesAt__y + naalaa_ToInt(prt_ParticlesF[SP_DoParticlesAt__i][PRT_Y]), SP_DoParticlesAt__cel);
						} else {
							naalaa_DrawImage(prt_Particles[SP_DoParticlesAt__i][PRT_IMAGE], SP_DoParticlesAt__x + naalaa_ToInt(prt_ParticlesF[SP_DoParticlesAt__i][PRT_X]), SP_DoParticlesAt__y + naalaa_ToInt(prt_ParticlesF[SP_DoParticlesAt__i][PRT_Y]), prt_Particles[SP_DoParticlesAt__i][PRT_CEL]);
						}
					}
				}
			}
		}
		// 0
		setColor(255, 255, 255, 255);
	}

//////////////////////////////////////////////////////////////////////
// Subroutine HS_Init.
//////////////////////////////////////////////////////////////////////
void HS_Init(int HS_Init__maxEntries, String HS_Init__standardName, int HS_Init__maxScore) throws NaaLaaEndException {
// Locals.
int HS_Init__i = 0;

		hs_MaxEntries = HS_Init__maxEntries;
		hs_Scores = new Integer[hs_MaxEntries];
naalaa_IntArrayInit(hs_Scores);
		hs_Names = new String[hs_MaxEntries];
naalaa_StringArrayInit(hs_Names);
		for (HS_Init__i = 0; HS_Init__i <= hs_MaxEntries - 1; HS_Init__i++) {
			hs_Names[hs_MaxEntries - HS_Init__i - 1] = (HS_Init__standardName);
			hs_Scores[hs_MaxEntries - HS_Init__i - 1] = HS_Init__i*HS_Init__maxScore/HS_Init__maxEntries + naalaa_Random.nextInt(HS_Init__maxScore/HS_Init__maxEntries);
		}
	}

//////////////////////////////////////////////////////////////////////
// Subroutine HS_Load.
//////////////////////////////////////////////////////////////////////
int HS_Load(String HS_Load__filename) throws NaaLaaEndException {
// Locals.
int HS_Load__i = 0;

		naalaa_OpenFile(0, (HS_Load__filename), 0);
		if (!(naalaa_File(0) != 0 )) {
			return 0;
		}
		hs_MaxEntries = naalaa_FileReadInt(0);
		hs_Scores = new Integer[hs_MaxEntries];
naalaa_IntArrayInit(hs_Scores);
		hs_Names = new String[hs_MaxEntries];
naalaa_StringArrayInit(hs_Names);
		for (HS_Load__i = 0; HS_Load__i <= hs_MaxEntries - 1; HS_Load__i++) {
			hs_Names[HS_Load__i] = (naalaa_FileReadString(0));
			hs_Scores[HS_Load__i] = naalaa_FileReadInt(0);
		}
		naalaa_FreeFile(0);
		return 1;
	}

//////////////////////////////////////////////////////////////////////
// Subroutine HS_Save.
//////////////////////////////////////////////////////////////////////
int HS_Save(String HS_Save__filename) throws NaaLaaEndException {
// Locals.
int HS_Save__i = 0;

		naalaa_CreateFile(0, (HS_Save__filename), 0);
		if (!(naalaa_File(0) != 0 )) {
			return 0;
		}
		naalaa_WriteFile(0, new String().valueOf(hs_MaxEntries), 1);
		for (HS_Save__i = 0; HS_Save__i <= hs_MaxEntries - 1; HS_Save__i++) {
			naalaa_WriteFile(0, new String().valueOf((hs_Names[HS_Save__i])), 1);
			naalaa_WriteFile(0, new String().valueOf(hs_Scores[HS_Save__i]), 1);
		}
		naalaa_FreeFile(0);
		return 1;
	}

//////////////////////////////////////////////////////////////////////
// Subroutine HS_GetName.
//////////////////////////////////////////////////////////////////////
String HS_GetName(int HS_GetName__index) throws NaaLaaEndException {
		if (HS_GetName__index < 0 || HS_GetName__index >= hs_MaxEntries) {
			return ("");
		}
		return (hs_Names[HS_GetName__index]);
	}

//////////////////////////////////////////////////////////////////////
// Subroutine HS_GetScore.
//////////////////////////////////////////////////////////////////////
int HS_GetScore(int HS_GetScore__index) throws NaaLaaEndException {
		if (HS_GetScore__index < 0 || HS_GetScore__index >= hs_MaxEntries) {
			return  - 1;
		}
		return hs_Scores[HS_GetScore__index];
	}

//////////////////////////////////////////////////////////////////////
// Subroutine HS_GetNames.
//////////////////////////////////////////////////////////////////////
String[] HS_GetNames() throws NaaLaaEndException {
		return (String[])hs_Names.clone();
	}

//////////////////////////////////////////////////////////////////////
// Subroutine HS_GetScores.
//////////////////////////////////////////////////////////////////////
Integer[] HS_GetScores() throws NaaLaaEndException {
		return (Integer[])hs_Scores.clone();
	}

//////////////////////////////////////////////////////////////////////
// Subroutine HS_IsQualified.
//////////////////////////////////////////////////////////////////////
int HS_IsQualified(int HS_IsQualified__score) throws NaaLaaEndException {
// Locals.
int HS_IsQualified__index = 0;

		for (HS_IsQualified__index = 0; HS_IsQualified__index <= hs_MaxEntries - 1; HS_IsQualified__index++) {
			if (HS_IsQualified__score > hs_Scores[HS_IsQualified__index]) {
				break;
			}
		}
		if (HS_IsQualified__index < hs_MaxEntries) {
			return 1;
		} else {
			return 0;
		}
	}

//////////////////////////////////////////////////////////////////////
// Subroutine HS_AddEntry.
//////////////////////////////////////////////////////////////////////
int HS_AddEntry(String HS_AddEntry__name, int HS_AddEntry__score) throws NaaLaaEndException {
// Locals.
int HS_AddEntry__index = 0;
int HS_AddEntry__i = 0;

		for (HS_AddEntry__index = 0; HS_AddEntry__index <= hs_MaxEntries - 1; HS_AddEntry__index++) {
			if (HS_AddEntry__score > hs_Scores[HS_AddEntry__index]) {
				break;
			}
		}
		if (HS_AddEntry__index < hs_MaxEntries) {
			for (HS_AddEntry__i = hs_MaxEntries - 1; HS_AddEntry__i >= HS_AddEntry__index + 1; HS_AddEntry__i--) {
				hs_Scores[HS_AddEntry__i] = hs_Scores[HS_AddEntry__i - 1];
				hs_Names[HS_AddEntry__i] = (hs_Names[HS_AddEntry__i - 1]);
			}
			hs_Scores[HS_AddEntry__index] = HS_AddEntry__score;
									hs_Names[HS_AddEntry__index] = (HS_AddEntry__name.replaceAll(naalaa_Chr(34), ""));
			if ((hs_Names[HS_AddEntry__index]).equals((""))) {
				hs_Names[HS_AddEntry__index] = (hs_DefaultName);
			}
			return 1;
		}
		return 0;
	}

//////////////////////////////////////////////////////////////////////
// Subroutine HS_SetDefaultName.
//////////////////////////////////////////////////////////////////////
void HS_SetDefaultName(String HS_SetDefaultName__name) throws NaaLaaEndException {
		hs_DefaultName = (HS_SetDefaultName__name);
		if ((HS_SetDefaultName__name).equals((""))) {
			HS_SetDefaultName__name = ("Noname");
		}
	}

//////////////////////////////////////////////////////////////////////
// Subroutine fire.
//////////////////////////////////////////////////////////////////////
void fire(int fire__sd) throws NaaLaaEndException {
		missile_available = 0;
		if (missiles_left > 0) {
			for (a = 0; a <= MISSILE_MAX - 1; a++) {
								if (MISSILE[a][MISSILE_FIRED] == 0.000000f && mouseButton(0, 1) != 0 ) {
					MISSILE[a][MISSILE_TARGET_X] = naalaa_ToFloat(x);
					MISSILE[a][MISSILE_TARGET_Y] = naalaa_ToFloat(y);
					missiles_left = missiles_left - 1;
					MISSILE[a][MISSILE_NEW_X] = naalaa_ToFloat(base2x);
					MISSILE[a][MISSILE_NEW_X_INC] = (naalaa_ToFloat(base2x) - MISSILE[a][MISSILE_TARGET_X])/MISSILE[a][MISSILE_TIMER2];
					MISSILE[a][MISSILE_NEW_Y] = naalaa_ToFloat(base2y);
					MISSILE[a][MISSILE_NEW_Y_INC] = (naalaa_ToFloat(base2y) - MISSILE[a][MISSILE_TARGET_Y])/MISSILE[a][MISSILE_TIMER2];
					MISSILE[a][MISSILE_FIRED] = 1.000000f;
					naalaa_PlaySound(MISSILE_SOUND, 100, 0);
				}
			}
		}
						for (a = 0; a <= MISSILE_MAX - 1; a++) {
						if (MISSILE[a][MISSILE_FIRED] == 0.000000f) {
				missile_available = missile_available + 1;
			}
		}
	}

//////////////////////////////////////////////////////////////////////
// Subroutine hit_base.
//////////////////////////////////////////////////////////////////////
void hit_base() throws NaaLaaEndException {
				for (a = 0; a <= ENEMY_MISSILE_MAX - 1; a++) {
			for (b = 0; b <= CITY_MAX - 1; b++) {
				if (cities[b][CITY_OK] == 1) {
					if (ENEMY_MISSILE[a][ENEMY_MISSILE_NEW_X] > naalaa_ToFloat(cities[b][CITY_X])) {
						if (ENEMY_MISSILE[a][ENEMY_MISSILE_NEW_X] < naalaa_ToFloat(cities[b][CITY_X] + naalaa_Width(CITY_IMAGE))) {
							if (ENEMY_MISSILE[a][ENEMY_MISSILE_NEW_Y] > naalaa_ToFloat(cities[b][CITY_Y])) {
								if (ENEMY_MISSILE[a][ENEMY_MISSILE_NEW_Y] < naalaa_ToFloat(cities[b][CITY_Y] + naalaa_Height(CITY_IMAGE)) + 2.000000f) {
									naalaa_PlaySound(EXP_SOUND, 100, 0);
									cities[b][CITY_OK] = 0;
									SP_AddPoof(EXP_IMAGE,  - 2, cities[b][CITY_X] + naalaa_Width(CITY_IMAGE)/2, cities[b][CITY_Y] + naalaa_Height(CITY_IMAGE)/2, 8, 4.000000f, 1.500000f, 0.025000f, 0, 1);
								}
							}
						}
					}
				}
			}
		}
				surviving_cities = 0;
				for (a = 0; a <= CITY_MAX - 1; a++) {
			if (cities[a][CITY_OK] == 1) {
				surviving_cities = surviving_cities + 1;
			}
		}
		if (surviving_cities == 0) {
			setColor(0, 0, 128, 255);
			naalaa_Cls();
			setColor(255, 255, 255, 255);
			naalaa_SetCaret(160, 90);
			naalaa_Center(new String().valueOf(("All of your Cities")));
			naalaa_Center(new String().valueOf(("have been destroyed .....")));
						paint(getGraphics());
			try {Thread.sleep(4000);} catch (InterruptedException e) {}
			high_score();
			end_game();
		}
				for (a = 0; a <= ENEMY_MISSILE_MAX - 1; a++) {
			if (ENEMY_MISSILE[a][ENEMY_MISSILE_NEW_X] > 160.000000f - naalaa_ToFloat(naalaa_Width(BASE_IMAGE)/2)) {
				if (ENEMY_MISSILE[a][ENEMY_MISSILE_NEW_X] < naalaa_ToFloat(160 + naalaa_Width(BASE_IMAGE)/2)) {
										if (ENEMY_MISSILE[a][ENEMY_MISSILE_NEW_Y] > 205.000000f) {
						if (ENEMY_MISSILE[a][ENEMY_MISSILE_NEW_Y] < naalaa_ToFloat(200 + naalaa_Height(BASE_IMAGE))) {
							naalaa_PlaySound(EXP_SOUND, 100, 0);
							setColor(0, 0, 128, 255);
							naalaa_Cls();
							setColor(255, 255, 255, 255);
							naalaa_SetCaret(160, 90);
							naalaa_Center(new String().valueOf(("Your Missile Base")));
							naalaa_Center(new String().valueOf(("has been destroyed .....")));
														paint(getGraphics());
							try {Thread.sleep(4000);} catch (InterruptedException e) {}
							high_score();
							end_game();
						}
					}
				}
			}
		}
	}

//////////////////////////////////////////////////////////////////////
// Subroutine next_level.
//////////////////////////////////////////////////////////////////////
void next_level() throws NaaLaaEndException {
// Locals.
int next_level__xpos2 = 0;
int next_level__xpos = 0;

		setColor(0, 0, 128, 255);
		naalaa_Cls();
		setColor(255, 255, 255, 255);
		level = level + 1;
		enemy_missile_fired = 0;
				if (en_missile_radius > 12.000000f) {
			en_missile_radius = en_missile_radius - 1.000000f;
		}
				surviving_cities = 0;
		for (a = 0; a <= CITY_MAX - 1; a++) {
			if (cities[a][CITY_OK] == 1) {
				surviving_cities = surviving_cities + 1;
			}
		}
		score = score + (surviving_cities*100) + (missiles_left*20);
		naalaa_SetCaret(WIDTH/2, 40);
		if (missiles_left == 1) {
			naalaa_Center(new String().valueOf(("You have ")) + new String().valueOf(missiles_left) + new String().valueOf((" missile left")));
		} else {
			naalaa_Center(new String().valueOf(("You have ")) + new String().valueOf(missiles_left) + new String().valueOf((" missiles left")));
		}
		naalaa_Center(new String().valueOf(("")));
		next_level__xpos2 = 163 - (missiles_left*6);
		for (a = 0; a <= missiles_left - 1; a++) {
			naalaa_DrawImage(MISSILE_IMAGE, next_level__xpos2, 60);
			next_level__xpos2 = next_level__xpos2 + 12;
		}
		naalaa_Center(new String().valueOf(("giving you a bonus of ")) + new String().valueOf(missiles_left*20));
		naalaa_Center(new String().valueOf(("--------------------------------- ")));
		if (surviving_cities == 1) {
			naalaa_Center(new String().valueOf(("You also have ")) + new String().valueOf(surviving_cities) + new String().valueOf((" city left")));
		} else {
			naalaa_Center(new String().valueOf(("You also have ")) + new String().valueOf(surviving_cities) + new String().valueOf((" cities left")));
		}
		next_level__xpos = 165 - (surviving_cities*20);
		for (a = 0; a <= surviving_cities - 1; a++) {
			naalaa_DrawImage(CITY_IMAGE, next_level__xpos, 125);
			next_level__xpos = next_level__xpos + 40;
		}
		naalaa_Center(new String().valueOf((" ")));
		naalaa_Center(new String().valueOf((" ")));
		naalaa_Center(new String().valueOf(("giving you a bonus of ")) + new String().valueOf(surviving_cities*100));
		naalaa_Center(new String().valueOf(("--------------------------------- ")));
		naalaa_Center(new String().valueOf((" ")));
		naalaa_Center(new String().valueOf(("Next level is level ")) + new String().valueOf(level));
				paint(getGraphics());
				for (a = 0; a <= MISSILE_MAX - 1; a++) {
			MISSILE[a][MISSILE_EXP_TIMER] = 151.000000f;
		}
		try {Thread.sleep(8000);} catch (InterruptedException e) {}
		missiles_left = MISSILE_MAX;
		start_level = 1;
	}

//////////////////////////////////////////////////////////////////////
// Subroutine end_game.
//////////////////////////////////////////////////////////////////////
void end_game() throws NaaLaaEndException {
		setColor(0, 0, 128, 255);
		naalaa_Cls();
		setColor(255, 255, 255, 255);
		naalaa_SetCaret(160, 90);
		naalaa_Center(new String().valueOf(("Game Over")));
				paint(getGraphics());
				for (a = 0; a <= ENEMY_MISSILE_MAX - 1; a++) {
			ENEMY_MISSILE[a][ENEMY_MISSILE_TARGET_X] = naalaa_ToFloat(naalaa_Random.nextInt(320));
			ENEMY_MISSILE[a][ENEMY_MISSILE_TARGET_Y] = 200.000000f + naalaa_ToFloat(naalaa_Height(BASE_IMAGE));
			ENEMY_MISSILE[a][ENEMY_MISSILE_START_X] = naalaa_ToFloat(naalaa_Random.nextInt(320));
			ENEMY_MISSILE[a][ENEMY_MISSILE_NEW_X] = ENEMY_MISSILE[a][ENEMY_MISSILE_START_X];
			ENEMY_MISSILE[a][ENEMY_MISSILE_NEW_X_INC] = (ENEMY_MISSILE[a][ENEMY_MISSILE_TARGET_X] - ENEMY_MISSILE[a][ENEMY_MISSILE_START_X])/ENEMY_MISSILE[a][ENEMY_MISSILE_TIMER2];
			ENEMY_MISSILE[a][ENEMY_MISSILE_START_Y] = -2.000000f;
			ENEMY_MISSILE[a][ENEMY_MISSILE_NEW_Y] = ENEMY_MISSILE[a][ENEMY_MISSILE_START_Y];
			ENEMY_MISSILE[a][ENEMY_MISSILE_NEW_Y_INC] = (ENEMY_MISSILE[a][ENEMY_MISSILE_TARGET_Y] - ENEMY_MISSILE[a][ENEMY_MISSILE_START_Y])/ENEMY_MISSILE[a][ENEMY_MISSILE_TIMER2];
			ENEMY_MISSILE[a][ENEMY_MISSILE_FIRED] = 0.000000f;
		}
		for (a = 0; a <= CITY_MAX - 1; a++) {
			cities[a][CITY_OK] = 1;
		}
		start_level = 1;
		score = 0;
		missiles_left = MISSILE_MAX;
		enemy_missile_allowed = ENEMY_MISSILE_MAX;
		enemy_missile_fired = 0;
		level = 1;
		try {Thread.sleep(4000);} catch (InterruptedException e) {}
		MenuScreen();
	}

//////////////////////////////////////////////////////////////////////
// Subroutine high_score.
//////////////////////////////////////////////////////////////////////
void high_score() throws NaaLaaEndException {
// Locals.
int high_score__didQualify = 0;
int high_score__i = 0;

				high_score__didQualify = HS_IsQualified(score);
		naalaa_SetCaret(160, 0);
		naalaa_Center(new String().valueOf(("YOUR SCORE: ")) + new String().valueOf(score));
		if (high_score__didQualify != 0 ) {
			get_name();
		}
		if (HS_AddEntry((name), score) != 0 ) {
			setColor(0, 0, 128, 255);
			naalaa_Cls();
			setColor(255, 255, 255, 255);
			naalaa_SetCaret(160, 110);
			naalaa_Center(new String().valueOf(("Congratulations........... ")));
			naalaa_Center(new String().valueOf((" you qualified as one of")));
			naalaa_Center(new String().valueOf((" the highest scorers...")));
		} else {
			setColor(0, 0, 128, 255);
			naalaa_Cls();
			setColor(255, 255, 255, 255);
			naalaa_SetCaret(160, 110);
			naalaa_Center(new String().valueOf(("Sorry, you did not qualify for ")));
			naalaa_Center(new String().valueOf(("the high score list.......")));
		}
				paint(getGraphics());
		setColor(0, 0, 128, 255);
		naalaa_Cls();
		setColor(255, 255, 255, 255);
		naalaa_SetCaret(160, 0);
		naalaa_Center(new String().valueOf(("YOUR SCORE: ")) + new String().valueOf(score));
		naalaa_SetCaret(85, 30);
		naalaa_Center(new String().valueOf(("Name")));
		naalaa_SetCaret(225, 30);
		naalaa_Justification = 1;
		naalaa_Write(new String().valueOf(("Score")), 0);
		for (high_score__i = 0; high_score__i <= 9; high_score__i++) {
			naalaa_SetCaret(70, high_score__i*16 + 50);
			naalaa_Justification = -1;
			naalaa_Write(new String().valueOf((HS_GetName(high_score__i))), 0);
			naalaa_SetCaret(220, high_score__i*16 + 50);
			naalaa_Justification = 1;
			naalaa_Write(new String().valueOf(HS_GetScore(high_score__i)), 0);
		}
				paint(getGraphics());
		try {Thread.sleep(4000);} catch (InterruptedException e) {}
		if (!(HS_Save(("hs_list.txt")) != 0 )) {
					}
				for (a = 0; a <= ENEMY_MISSILE_MAX - 1; a++) {
			ENEMY_MISSILE[a][ENEMY_MISSILE_TARGET_X] = naalaa_ToFloat(naalaa_Random.nextInt(320));
			ENEMY_MISSILE[a][ENEMY_MISSILE_TARGET_Y] = 200.000000f + naalaa_ToFloat(naalaa_Height(BASE_IMAGE));
			ENEMY_MISSILE[a][ENEMY_MISSILE_START_X] = naalaa_ToFloat(naalaa_Random.nextInt(320));
			ENEMY_MISSILE[a][ENEMY_MISSILE_NEW_X] = ENEMY_MISSILE[a][ENEMY_MISSILE_START_X];
			ENEMY_MISSILE[a][ENEMY_MISSILE_NEW_X_INC] = (ENEMY_MISSILE[a][ENEMY_MISSILE_TARGET_X] - ENEMY_MISSILE[a][ENEMY_MISSILE_START_X])/ENEMY_MISSILE[a][ENEMY_MISSILE_TIMER2];
			ENEMY_MISSILE[a][ENEMY_MISSILE_START_Y] = -2.000000f;
			ENEMY_MISSILE[a][ENEMY_MISSILE_NEW_Y] = ENEMY_MISSILE[a][ENEMY_MISSILE_START_Y];
			ENEMY_MISSILE[a][ENEMY_MISSILE_NEW_Y_INC] = (ENEMY_MISSILE[a][ENEMY_MISSILE_TARGET_Y] - ENEMY_MISSILE[a][ENEMY_MISSILE_START_Y])/ENEMY_MISSILE[a][ENEMY_MISSILE_TIMER2];
			ENEMY_MISSILE[a][ENEMY_MISSILE_FIRED] = 0.000000f;
		}
		for (a = 0; a <= CITY_MAX - 1; a++) {
			cities[a][CITY_OK] = 1;
		}
		start_level = 1;
		score = 0;
		missiles_left = MISSILE_MAX;
		enemy_missile_allowed = ENEMY_MISSILE_MAX;
		enemy_missile_fired = 0;
		level = 1;
			}

//////////////////////////////////////////////////////////////////////
// Subroutine get_name.
//////////////////////////////////////////////////////////////////////
void get_name() throws NaaLaaEndException {
				setColor(0, 0, 128, 255);
		naalaa_Cls();
		setColor(255, 255, 255, 255);
				naalaa_SetCaret(160, 0);
		naalaa_Center(new String().valueOf(("YOUR SCORE: ")) + new String().valueOf(score));
		naalaa_AutoRedraw = 1;
		naalaa_SetCaret(160, 40);
		naalaa_Center("");
		naalaa_Center(new String().valueOf(("Well done - you are one")));
		naalaa_Center(new String().valueOf(("of the top 10 scorers")));
		naalaa_Center(new String().valueOf(("Enter your name below..")));
		naalaa_Center(new String().valueOf(("")));
		name = (naalaa_ReadString(10));
		naalaa_AutoRedraw = 0;
	}

//////////////////////////////////////////////////////////////////////
// Subroutine MenuScreen.
//////////////////////////////////////////////////////////////////////
void MenuScreen() throws NaaLaaEndException {
// Locals.
int MenuScreen__menuItem = 0;
int MenuScreen__i = 0;
int MenuScreen__donotreturn = 0;

						do {
			MenuScreen__menuItem = 0;
			do {
								if (!(naalaa_Running != 0 )) {
					throw new NaaLaaEndException();
				}
				if (naalaa_KeyDown(VK_DOWN, 1) != 0  && MenuScreen__menuItem < 6) {
					MenuScreen__menuItem = MenuScreen__menuItem + 1;
				}
				if (naalaa_KeyDown(VK_UP, 1) != 0  && MenuScreen__menuItem > 0) {
					MenuScreen__menuItem = MenuScreen__menuItem - 1;
				}
				setColor(0, 0, 0, 255);
				naalaa_Cls();
				setColor(255, 255, 255, 64);
				naalaa_DrawImage(BG_IMAGE, 0, 0);
								naalaa_SetCaret(160, 25);
				setColor(0, 255, 255, 255);
				naalaa_Center(new String().valueOf(("Use Keys To Move in The Menu")));
				naalaa_Center(new String().valueOf(("Press Space to Select an Item")));
				naalaa_SetCaret(160, 80);
																																				if (MenuScreen__menuItem == 1) {
					setColor(0, 255, 255, 255);
				} else {
					setColor(0, 96, 128, 255);
				}
				naalaa_Center(new String().valueOf(("HOW TO PLAY THE GAME")));
								if (MenuScreen__menuItem == 2) {
					setColor(0, 255, 255, 255);
				} else {
					setColor(0, 96, 128, 255);
									}
				naalaa_Center(new String().valueOf(("PLAY AN EASY GAME")));
								if (MenuScreen__menuItem == 3) {
					setColor(0, 255, 255, 255);
				} else {
					setColor(0, 96, 128, 255);
									}
				naalaa_Center(new String().valueOf(("PLAY A HARD GAME")));
								if (MenuScreen__menuItem == 4) {
					setColor(0, 255, 255, 255);
				} else {
					setColor(0, 96, 128, 255);
				}
				naalaa_Center(new String().valueOf(("SEE THE HIGH SCORES")));
								if (MenuScreen__menuItem == 5) {
					setColor(0, 255, 255, 255);
				} else {
					setColor(0, 96, 128, 255);
				}
				naalaa_Center(new String().valueOf(("QUIT THE GAME")));
								if (MenuScreen__menuItem == 0) {
					setColor(0, 255, 255, 255);
				} else {
					setColor(0, 96, 128, 255);
				}
								paint(getGraphics());
				try {Thread.sleep(10);} catch (InterruptedException e) {}
			} while (!(naalaa_KeyDown(VK_SPACE, 1) != 0 ));
			if (MenuScreen__menuItem == 1) {
				setColor(0, 0, 0, 255);
				naalaa_Cls();
				setColor(255, 0, 255, 255);
				naalaa_SetCaret(160, 10);
								naalaa_Center(new String().valueOf(("***** HOW TO PLAY *****")));
								naalaa_Center(new String().valueOf(("")));
				setColor(0, 255, 255, 255);
				naalaa_Center(new String().valueOf(("Your Mission is to Destroy")));
				naalaa_Center(new String().valueOf(("all alien missiles")));
				naalaa_Center(new String().valueOf(("")));
				naalaa_Center(new String().valueOf(("Use the mouse to move the target")));
				naalaa_Center(new String().valueOf(("Sight and Left click to fire")));
				naalaa_Center(new String().valueOf(("")));
				naalaa_Center(new String().valueOf(("The game ends when all cities")));
				naalaa_Center(new String().valueOf(("are destroyed or a missile")));
				naalaa_Center(new String().valueOf(("hits your missile base")));
				naalaa_Center(new String().valueOf(("")));
				setColor(255, 255, 255, 255);
				naalaa_Center(new String().valueOf(("Press any key to continue...")));
								paint(getGraphics());
				naalaa_WaitKeyDown();
							} else if (MenuScreen__menuItem == 4) {
				setColor(0, 0, 128, 255);
				naalaa_Cls();
				setColor(255, 255, 255, 255);
				naalaa_SetCaret(160, 0);
				naalaa_SetCaret(85, 10);
				naalaa_Center(new String().valueOf(("Name")));
				naalaa_SetCaret(225, 10);
				naalaa_Justification = 1;
				naalaa_Write(new String().valueOf(("Score")), 0);
				for (MenuScreen__i = 0; MenuScreen__i <= 9; MenuScreen__i++) {
					naalaa_SetCaret(70, MenuScreen__i*16 + 30);
					naalaa_Justification = -1;
					naalaa_Write(new String().valueOf((HS_GetName(MenuScreen__i))), 0);
					naalaa_SetCaret(220, MenuScreen__i*16 + 30);
					naalaa_Justification = 1;
					naalaa_Write(new String().valueOf(HS_GetScore(MenuScreen__i)), 0);
				}
				naalaa_SetCaret(160, 200);
				naalaa_Center(new String().valueOf(("Press any key to continue...")));
								paint(getGraphics());
				naalaa_WaitKeyDown();
																			} else if (MenuScreen__menuItem == 2) {
				en_missile_radius = 22.000000f;
				MenuScreen__donotreturn = 1;
			} else if (MenuScreen__menuItem == 3) {
				en_missile_radius = 14.000000f;
				MenuScreen__donotreturn = 1;
							} else if (MenuScreen__menuItem == 5) {
				throw new NaaLaaEndException();
			}
					} while (!(MenuScreen__menuItem == 2 || MenuScreen__menuItem == 3));
	}

